'  Chat in Macromedia Flash MX e Microsoft .Net
'  by Ricciolo


Imports System
Imports Microsoft.VisualBasic
Imports System.Diagnostics
Imports System.Net
Imports System.Web
Imports System.Net.Sockets
Imports System.IO
Imports System.Text
Imports System.Xml
Imports System.Collections

Namespace Chat

    Public Class FlashChat

        'ricevitore connessioni utenti
        Private Listener As Socket
        Private _Port As Short = 1400S
        Private _Users As ArrayList
        Private _MaxConnections As Short = 100

        Public ChatName As String = "FlashChat"

        Public Event OnChatError(ByVal Sender As Object, ByVal e As Exception)


        Public Sub New()
            CreateUsers()
        End Sub

        Private Sub CreateUsers()
            _Users = ArrayList.Synchronized(New ArrayList(_MaxConnections))
        End Sub

        Public Property MaxConnections() As Short
            Get
                Return _MaxConnections
            End Get
            Set(ByVal Value As Short)
                If Me.Listening Then Throw New ArgumentException("Cannot change property while listening")

                _MaxConnections = Value

                CreateUsers()
            End Set
        End Property

        Public Property Port() As Short
            Get
                Return _Port
            End Get
            Set(ByVal Value As Short)
                _Port = Value
            End Set
        End Property

        Public ReadOnly Property Users() As ArrayList
            Get
                Return _Users
            End Get

        End Property

        Public ReadOnly Property Listening() As Boolean
            Get
                Return Not (Listener Is Nothing)
            End Get
        End Property

        Public Sub SendToUser(ByRef User As User, ByRef Command As String)
            Dim size As Short = Command.Length + 1
            'converto il comando stringa in byte
            'aggiungendo il carattere di fine comando chr(0)
            Dim buffer() As Byte = Encoding.ASCII.GetBytes(Command & Chr(0))

            dWrite("Invio a " & User.Nickname & ": " & Command)
            'invia
            Try
                User.SListener.BeginSend(buffer, 0, size, 0, New AsyncCallback(AddressOf SendCallBack), User.SListener)
            Catch
            End Try
        End Sub

        Public Sub SendToAll(ByRef Command As String)
            Dim x As Short
            For x = 0 To _Users.Count - 1
                Me.SendToUser(_Users(x), Command)
            Next x
        End Sub

        Private Sub SendToCurrent(ByRef Command As String, ByRef State As User)
            Dim size As Short = Command.Length + 1
            'converto il comando stringa in byte
            'aggiungendo il carattere di fine comando chr(0)
            Dim buffer() As Byte = Encoding.ASCII.GetBytes(Command & Chr(0))

            dWrite("Invio: " & Command)
            'invia
            State.SListener.Send(buffer, size, 0)
        End Sub

        Private Sub ProcessLine(ByRef Line As String, ByRef State As User)
            'ogni comando termina con il carattere ASCII 0
            'devo prevedere che giunga l'intera linea

            'lo aggiungo ai precedenti caratteri ricevuti
            State.Line.Append(Line)

            'se termina con il carattere 0 allora fine riga e lo processo
            If Not Line.EndsWith(Chr(0)) OrElse State.Line.Length = 0 Then Exit Sub

            dWrite(State.Line.ToString)

            Dim Cmd As New XmlDocument()
            Try
                'parserizzo il comando
                Cmd.LoadXml(State.Line.ToString())
            Catch : Exit Sub
            Finally
                'riazzero i caratteri ricevuti
                State.Line.Remove(0, State.Line.Length)
            End Try


            Select Case Cmd.FirstChild.Name
                'comando per entrare in chat
                '<login nick="piero"/>
            Case "login"
                    'prelevo il nickname
                    Dim Nick As String = Cmd.FirstChild.Attributes("nick").Value
                    'verifico la sua univocit
                    If _Users.BinarySearch(Nick) < 0 Then
                        'pu entrare
                        State.Nickname = Nick
                        'aggiungo alla lista utenti
                        _Users.Add(State)
                        _Users.Sort()
                        Me.SendToCurrent("<login>ok</login>", State)

                        Me.SendToAll("<join nick=""" & State.Nickname & """/>")
                    Else
                        'non pu entrare
                        Me.SendToCurrent("<login>Nick name gi esistente</login>", State)
                    End If
                Case "msg"
                    If CBool(Cmd.FirstChild.Attributes("tipo").Value) = False Then
                        'messaggio normale
                        'invio a tutti
                        Me.SendToAll(Cmd.OuterXml)
                    Else
                        'messaggio privato
                        'ricerco la classe del destinatario
                        Dim x As Short
                        x = _Users.BinarySearch(Cmd.FirstChild.Attributes("to").Value)
                        If x = -1 Then Exit Sub
                        'invio solo al destinatario
                        Me.SendToUser(_Users(x), Cmd.OuterXml)
                        'invio al miettente
                        x = _Users.BinarySearch(Cmd.FirstChild.Attributes("from").Value)
                        If x = -1 Then Exit Sub
                        Me.SendToUser(_Users(x), Cmd.OuterXml)
                    End If
                Case "listusers"
                    'invio lista utenti
                    Me.SendListUserToCurrent(State)
            End Select
        End Sub

        'funzione per prepare messaggi da parte della chat
        Public Function GetXmlFormat(ByRef Cmd As String, ByRef From As String, Optional ByRef ToUser As String = "", Optional ByVal Tipo As Boolean = 0) As String
            'tipo 0: messaggio normale
            'tipo 1: messaggio privato
            Dim xmlDoc As New XmlDocument()
            Dim xmlAtt As XmlAttribute
            Dim riga As XmlElement = xmlDoc.CreateElement("msg")
            'attributo contentente il nickname del mandante
            xmlAtt = xmlDoc.CreateAttribute("from")
            xmlAtt.Value = From
            riga.Attributes.Append(xmlAtt)
            'attributo contentente il tipo del messaggio
            xmlAtt = xmlDoc.CreateAttribute("tipo")
            xmlAtt.Value = Tipo
            riga.Attributes.Append(xmlAtt)
            'contenuto messaggio
            riga.InnerText = Cmd
            Return riga.OuterXml
        End Function

        Private Sub SendListUserToCurrent(ByRef State As User)
            Dim x As Short
            Dim xmlLUser As New XmlDocument()
            'ramo principale
            Dim listuser As XmlElement = xmlLUser.CreateElement("users")
            Dim xmlUser As XmlElement
            Dim xmlAtt As XmlAttribute
            For x = 0 To _Users.Count - 1
                'creo il ramo
                xmlUser = xmlLUser.CreateElement("user")
                'attributo contentente il nickname
                xmlAtt = xmlLUser.CreateAttribute("nick")
                xmlAtt.Value = CType(_Users(x), User).Nickname
                'lo aggiungo al ramo
                xmlUser.Attributes.Append(xmlAtt)
                listuser.AppendChild(xmlUser)
            Next x

            'invio la lista sotto forma di stringa
            Me.SendToCurrent(listuser.OuterXml, State)
        End Sub

        Private Sub SendCallBack(ByVal ar As IAsyncResult)
            CType(ar.AsyncState, Socket).EndSendTo(ar)
        End Sub

        Private Sub ReceiveCallBack(ByVal ar As IAsyncResult)
            Dim Size As Integer
            Dim State As User = DirectCast(ar.AsyncState, User)
            Size = State.SListener.EndReceive(ar)
            If Size > 0 Then
                State.BufferSize = Size
                'trasformo il buffer che  in byte in stringa
                Dim Line As String = Encoding.ASCII.GetString(State.Buffer, 0, Size)
                ProcessLine(Line, State)
                'ricomincio a ricevere in modo asincrono
                State.SListener.BeginReceive(State.Buffer, 0, State.BufferSize, 0, New AsyncCallback(AddressOf ReceiveCallBack), State)
            Else
                'si  disconnesso
                _Users.Remove(State)
                _Users.Sort()
                'invio a tutti l'uscita
                If State.Nickname <> "" Then Me.SendToAll("<quit nick=""" & State.Nickname & """/>")
                'annullo dal punto di vista la logico le variabili di riferimento
                State.Nickname = Nothing
                State.SListener = Nothing
                State.Line = Nothing
                State = Nothing
            End If
        End Sub

        Private Sub AcceptCallBack(ByVal ar As IAsyncResult)
            'per mantenere lo stato
            Dim State As New User()
            Dim handler As Socket
            'termino con l'accettazione di richiesta connessione
            handler = Listener.EndAccept(ar)
            State.SListener = handler
            'ricomincio a aspettare nuove connessioni
            Listener.BeginAccept(New AsyncCallback(AddressOf AcceptCallBack), Listener)
            'comincio a ricevere i dati da questo utente
            handler.BeginReceive(State.Buffer, 0, State.BufferSize, 0, New AsyncCallback(AddressOf ReceiveCallBack), State)
        End Sub

        Private Sub SListen()
            'controllo se non gi connesso
            If Not Listener Is Nothing Then
                Throw New WebException("Already listening") : Exit Sub : End If

            Trace.AutoFlush = True
            Trace.Listeners.Add(New System.Diagnostics.TextWriterTraceListener("C:\Inetpub\wwwroot\prove\FlashChat\log.txt"))

            dWrite("User syncronized: " & _Users.IsSynchronized)

            Try
                'risolvo il nome localhost
                Dim ipHostInfo As IPHostEntry = Dns.Resolve(Dns.GetHostName())
                Dim localEP As New IPEndPoint(ipHostInfo.AddressList(0), _Port)
                'inizializzo il listener
                Listener = New Socket(localEP.Address.AddressFamily, SocketType.Stream, ProtocolType.Tcp)

                With Listener
                    .Bind(localEP)
                    '100 numero massimo connessioni
                    .Listen(_MaxConnections)
                    'inizio ad accettare le richieste
                    .BeginAccept(New AsyncCallback(AddressOf AcceptCallBack), Listener)
                    dWrite("Start listening")
                End With
            Catch e As Exception
		dWrite(E.toString)
                RaiseEvent OnChatError(Me, e)
            End Try
        End Sub

        Public Overloads Sub StartListen()
            SListen()
        End Sub

        Public Sub StopListen()
            If Listener Is Nothing Then
                Throw New WebException("Not listening") : Exit Sub : End If

            'chiudo scrittura debug
            On Error Resume Next
            dWrite("Stop listening")
            Listener.Shutdown(SocketShutdown.Both)
            _Users.Clear()
            Listener = Nothing
        End Sub

        Public Overloads Sub StartListen(ByVal Port As Short)
            Me._Port = Port
            SListen()
        End Sub


        Private Sub dWrite(ByRef s As String)
            Trace.WriteLine(DateTime.Now & " " & s)
        End Sub

    End Class



    Public Class User
        Implements IComparable

        Public Buffer(255) As Byte
        Public BufferSize As Integer = 256
        Public SListener As Socket = Nothing
        Public Line As New StringBuilder()
        Public Nickname As String

        Public ReadOnly Property Ip() As String
            Get
                If Not Me.SListener Is Nothing Then Return CType(Me.SListener.RemoteEndPoint, IPEndPoint).Address.ToString
            End Get
        End Property

        Function CompareTo(ByVal obj As Object) As Integer Implements IComparable.CompareTo
            Dim n As String
            If obj.GetType Is Me.GetType Then
                n = DirectCast(obj, User).Nickname
            Else
                n = CStr(obj)
            End If

            Return Me.Nickname.CompareTo(n)
        End Function

    End Class


End Namespace
